<template>
  <page>
    <a-form
      class="notificacao-form"
      @submit="handleSubmit"
    >
      <h1>Preencha os dados da notícia</h1>
      <a-form-item
        label="Título da notícia"
        class="input-icon"
        required="true"
      >
        <a-input
          v-model="title"
          placeholder="Digite o título da notícia"
          type="text"
          :maxlength="titleLimit"
          required="true"
        />
        <p>{{ titleLimit - title.length }} caracteres restantes</p>
      </a-form-item>

      <a-form-item
        label="Descrição da notícia"
        class="input-icon"
        required="true"
      >
        <a-textarea
          v-model="description"
          placeholder="Digite aqui sua mensagem"
          :rows="6"
          :maxlength="messageLimit"
        />
        <p>{{ messageLimit - description.length }} caracteres restantes</p>
      </a-form-item>

      <a-form-item
        label="Foto da notícia"
        class="input-icon"
        required="true"
      >
        <a-upload-dragger
          :file-list="fileList"
          :remove="handleRemove"
          :before-upload="beforeUpload"
        >
          <p class="ant-upload-drag-icon">
            <a-icon type="inbox" />
          </p>
          <p class="ant-upload-text">
            Clique ou arraste a foto para essa área
          </p>
        </a-upload-dragger>
      </a-form-item>

      <a-form-item
        label="Conteúdo da notícia"
        class="input-icon"
        required="true"
      >
        <v-editor
          :clear-content="clearContent"
          @content-changed="handleContentChanged"
        />
      </a-form-item>

      <a-form-item>
        <a-button
          html-type="submit"
          type="primary"
          class="submit-button"
          :disabled="uploading"
        >
          <span v-if="uploading">
            <a-icon type="loading" />
          </span>
          <span v-else>Enviar</span>
        </a-button>
      </a-form-item>
    </a-form>
  </page>
</template>

<script>
import VEditor from '@/components/VEditor.vue';
import uploadDragger from '@/mixins/upload-dragger';
import editorContent from '@/mixins/editor';

export default {
  name: 'News',
  components: {
    VEditor,
  },
  mixins: [uploadDragger, editorContent],
  data() {
    return {
      title: '',
      description: '',
      titleLimit: 25,
      messageLimit: 235,
      uploading: false,
    };
  },
  methods: {
    async handleSubmit(e) {
      e.preventDefault();
      if (this.checkFields()) {
        try {
          this.uploading = true;

          const formData = this.createFormData();
          await this.$http.post('/news', formData);

          this.$message.success('Notícia adicionada com sucesso.');

          this.clearFields();
          this.uploading = false;
        } catch (error) {
          this.uploading = false;
          this.$message.error('Ocorreu um erro ao tentar adicionar o parceiro. Tente novamente mais tarde.');
        }
      } else {
        this.$message.error('Por favor preencha todos os dados obrigatórios!');
      }
    },
    checkFields() {
      return this.title && this.content && this.description && this.checkFileList();
    },
    createFormData() {
      const formData = new FormData();

      if (this.checkFileList()) {
        formData.append('image', this.fileList[0]);
      }

      formData.append('title', this.title);
      formData.append('description', this.description);
      formData.append('text', this.content);

      return formData;
    },
    clearFields() {
      this.fileList = [];
      this.title = '';
      this.description = '';
      this.clearEditorContent();
    },
  },
};
</script>

<style lang="stylus" scoped>
.submit-button
  float right
</style>
